package com.hai.dao;

import com.hai.entity.HighGoodsPriceRefer;
import com.hai.entity.HighGoodsPriceReferExample.Criteria;
import com.hai.entity.HighGoodsPriceReferExample.Criterion;
import com.hai.entity.HighGoodsPriceReferExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighGoodsPriceReferSqlProvider {

    public String countByExample(HighGoodsPriceReferExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_goods_price_refer");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighGoodsPriceReferExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_goods_price_refer");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighGoodsPriceRefer record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_goods_price_refer");
        
        if (record.getObjectType() != null) {
            sql.VALUES("object_type", "#{objectType,jdbcType=INTEGER}");
        }
        
        if (record.getObjectId() != null) {
            sql.VALUES("object_id", "#{objectId,jdbcType=BIGINT}");
        }
        
        if (record.getPriceType() != null) {
            sql.VALUES("price_type", "#{priceType,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountNum() != null) {
            sql.VALUES("discount_num", "#{discountNum,jdbcType=DECIMAL}");
        }
        
        if (record.getOldSalePrice() != null) {
            sql.VALUES("old_sale_price", "#{oldSalePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getNewSalePrice() != null) {
            sql.VALUES("new_sale_price", "#{newSalePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPromptlyType() != null) {
            sql.VALUES("promptly_type", "#{promptlyType,jdbcType=BIT}");
        }
        
        if (record.getEffectiveTime() != null) {
            sql.VALUES("effective_time", "#{effectiveTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getInvalidTime() != null) {
            sql.VALUES("invalid_time", "#{invalidTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRemark() != null) {
            sql.VALUES("remark", "#{remark,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.VALUES("operator_id", "#{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.VALUES("operator_name", "#{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighGoodsPriceReferExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("object_type");
        sql.SELECT("object_id");
        sql.SELECT("price_type");
        sql.SELECT("discount_num");
        sql.SELECT("old_sale_price");
        sql.SELECT("new_sale_price");
        sql.SELECT("promptly_type");
        sql.SELECT("effective_time");
        sql.SELECT("invalid_time");
        sql.SELECT("remark");
        sql.SELECT("create_time");
        sql.SELECT("operator_id");
        sql.SELECT("operator_name");
        sql.SELECT("`status`");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_goods_price_refer");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighGoodsPriceRefer record = (HighGoodsPriceRefer) parameter.get("record");
        HighGoodsPriceReferExample example = (HighGoodsPriceReferExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_goods_price_refer");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getObjectType() != null) {
            sql.SET("object_type = #{record.objectType,jdbcType=INTEGER}");
        }
        
        if (record.getObjectId() != null) {
            sql.SET("object_id = #{record.objectId,jdbcType=BIGINT}");
        }
        
        if (record.getPriceType() != null) {
            sql.SET("price_type = #{record.priceType,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountNum() != null) {
            sql.SET("discount_num = #{record.discountNum,jdbcType=DECIMAL}");
        }
        
        if (record.getOldSalePrice() != null) {
            sql.SET("old_sale_price = #{record.oldSalePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getNewSalePrice() != null) {
            sql.SET("new_sale_price = #{record.newSalePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPromptlyType() != null) {
            sql.SET("promptly_type = #{record.promptlyType,jdbcType=BIT}");
        }
        
        if (record.getEffectiveTime() != null) {
            sql.SET("effective_time = #{record.effectiveTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getInvalidTime() != null) {
            sql.SET("invalid_time = #{record.invalidTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRemark() != null) {
            sql.SET("remark = #{record.remark,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_goods_price_refer");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("object_type = #{record.objectType,jdbcType=INTEGER}");
        sql.SET("object_id = #{record.objectId,jdbcType=BIGINT}");
        sql.SET("price_type = #{record.priceType,jdbcType=INTEGER}");
        sql.SET("discount_num = #{record.discountNum,jdbcType=DECIMAL}");
        sql.SET("old_sale_price = #{record.oldSalePrice,jdbcType=DECIMAL}");
        sql.SET("new_sale_price = #{record.newSalePrice,jdbcType=DECIMAL}");
        sql.SET("promptly_type = #{record.promptlyType,jdbcType=BIT}");
        sql.SET("effective_time = #{record.effectiveTime,jdbcType=TIMESTAMP}");
        sql.SET("invalid_time = #{record.invalidTime,jdbcType=TIMESTAMP}");
        sql.SET("remark = #{record.remark,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighGoodsPriceReferExample example = (HighGoodsPriceReferExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighGoodsPriceRefer record) {
        SQL sql = new SQL();
        sql.UPDATE("high_goods_price_refer");
        
        if (record.getObjectType() != null) {
            sql.SET("object_type = #{objectType,jdbcType=INTEGER}");
        }
        
        if (record.getObjectId() != null) {
            sql.SET("object_id = #{objectId,jdbcType=BIGINT}");
        }
        
        if (record.getPriceType() != null) {
            sql.SET("price_type = #{priceType,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountNum() != null) {
            sql.SET("discount_num = #{discountNum,jdbcType=DECIMAL}");
        }
        
        if (record.getOldSalePrice() != null) {
            sql.SET("old_sale_price = #{oldSalePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getNewSalePrice() != null) {
            sql.SET("new_sale_price = #{newSalePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPromptlyType() != null) {
            sql.SET("promptly_type = #{promptlyType,jdbcType=BIT}");
        }
        
        if (record.getEffectiveTime() != null) {
            sql.SET("effective_time = #{effectiveTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getInvalidTime() != null) {
            sql.SET("invalid_time = #{invalidTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRemark() != null) {
            sql.SET("remark = #{remark,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighGoodsPriceReferExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}